#include <thrust/iterator/permutation_iterator.h>
#include <thrust/device_vector.h>
#include <thrust/reduce.h>
#include <cstdio>
using namespace thrust;

int main(){
	device_vector<int> map(4);
	device_vector<int> source(6);

	map[0] = 3;
	map[1] = 1;
	map[2] = 0;
	map[3] = 5;

	source[0] = 10;
	source[1] = 20;
	source[2] = 30;
	source[3] = 40;
	source[4] = 50;
	source[5] = 60;

	int sum = reduce(make_permutation_iterator(source.begin(), map.begin()),
			         make_permutation_iterator(source.end(), map.end()) );

	printf("%d\n", sum);

	return 0;
}
